//#1 флаги
const int MSG_End = 8 ; // количество исслед каналов
uint8_t msgFlag[MSG_End] =      {0, 0, 0, 0, 0, 0, 0, 0}; // флаги текущих состояний UPS (1 - это авария)
void ledControl() { // моргание нужными LED
}
//#2  дисплей
const char * message[MSG_End] = {  // сообщения об авариях
  "1:UPS1 Inver OFF",
  "2:UPS1 On Batter",
  "3:UPS1 Gen Alarm",
  "4:UPS1 Inver ON ",
  "5:UPS2 Inver OFF",
  "6:UPS2 ON Batter",
  "7:UPS2 Gen Alarm",
  "8:UPS2 Inver ON ",
};

#include <LiquidCrystal_I2C.h>

#include <Wire.h> 

#include <Bounce2.h>

#include <avr/wdt.h>
 
Bounce bouncer = Bounce();
 
LiquidCrystal_I2C lcd(0x27,16,2);  // устанавливаем адрес 0x27, и дисплей 16 символов в 2 строки (16х2)
//LiquidCrystal_I2C lcd(0x3F,20,4);  // устанавливаем адрес 0x3F, и дисплей 20 символов в 4 строки (16х2)

#define LED_PINA 3   //relay 1
#define LED_PINB 4   //relay 2
#define LED_PINC 5   //relay 3
#define LED_PIND 6   //relay 4
#define LED_PINE 7   //relay 5
#define LED_PINF 8   //relay 6
#define LED_PING 9   //relay 7
#define LED_PINJ 10  //relay 8


#define RXTX_PIN 17       // RXTX ACTIVATION

#define BEEP_PINK 2 // Пищалка сигнал при сработке

#define LED_PINS 11 // Лед сигнал о нормальной связи

#define BUTTON_TEST 12     // Тестовая кнопка проверки связи




int _previousValueTEST = 0;
int soundPin = 2; //объявляем переменную с номером пина, на который мы подключили пьезоэлемент

void setup() 
{
  bouncer.attach(12); // устанавливаем кнопку
  bouncer.interval(150); // устанавливаем параметр stable interval = 150 мс
  Serial.begin(9600);
  
  lcd.init();                     // инициализация LCD 
  lcd.backlight();                // включаем подсветку
  SobitieLogo();
  //SobitieLCD;

  pinMode(LED_PINA, OUTPUT);  // LED 1
  pinMode(LED_PINB, OUTPUT);  // LED 2
  pinMode(LED_PINC, OUTPUT);  // LED 3
  pinMode(LED_PIND, OUTPUT);  // LED 4
  pinMode(LED_PINE, OUTPUT);  // LED 5
  pinMode(LED_PINF, OUTPUT);  // LED 6
  pinMode(LED_PING, OUTPUT);  // LED 7
  pinMode(LED_PINJ, OUTPUT);  // LED 8
  pinMode(soundPin, OUTPUT);  // BEEPER
  pinMode(LED_PINS, OUTPUT);  // LED TEST

  pinMode(RXTX_PIN, OUTPUT);  // RX/TX on off

  pinMode(BUTTON_TEST, INPUT);

  digitalWrite(RXTX_PIN, LOW);
  
 _previousValueTEST = digitalRead(BUTTON_TEST);

 wdt_enable(WDTO_8S);          // 8 сек

}


void loop()
{
  static uint32_t MILLIS ;
  MILLIS = millis() ;
  //#1 флаги
  ledControl();                 // моргание нужными LED
  //#2 1000 милисек дисплей
  static uint32_t future2 = 0 ;
  if (MILLIS >= future2) {
    future2 = MILLIS + 1000 ;
    displayData();       // отображение информации
  }
 
  static uint32_t future5 = 10000 ;
  if (MILLIS >= future5) 
  {
    future5 = MILLIS + 1000 ;
    //readSerial(RX_PIN);           // слушаем Serial
    dataManager();                // обработка данных
    //sendData(TX_PIN);             // отправка данных
  }

  static uint32_t future6 = 60000 ;
  if (MILLIS >= future6) 
  {
    future6 = MILLIS + 60000 ;
    digitalWrite(RXTX_PIN, HIGH);
    delay(1);
    Serial.print('Z'); //вывод сообщения о нажатии
    delay(1);
    digitalWrite(RXTX_PIN, LOW);
  }



  
  //displayData();                // отображение информации
  if (bouncer.update())
  { //если произошло событие
    if (bouncer.read()==0)
     { //если кнопка нажата
       digitalWrite(RXTX_PIN, HIGH);
       delay(1);
       Serial.print('Z'); //вывод сообщения о нажатии
       delay(1);
       digitalWrite(RXTX_PIN, LOW);
     }
  }
  if(Serial.available()>0)
  {
    readSerial();
  }
  wdt_reset();  // сброс сторожевого таймера  
  
} //LOOP
